<?php

namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\FindService;
use SM\Traits\TResponse;
use SM\Service\FuncionariosHierarqService;

class FindController extends SMCrud
{
    use TResponse;
    protected $FindService;

    public function __construct($crudService, $environment, FindService $FindService)
    {
        parent::__construct($crudService, $environment);
        $this->FindService = $FindService;
    }

    public function findContrato(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findContrato($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findEscopoFaturamento(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findEscopoFaturamento($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findModeloContrato(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findModeloContrato($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findHabilidades(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findHabilidades($filtro);
            $this->sendResponse($data, $filtro, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findParceiroNegocio(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findParceiroNegocio($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findOperadorHierarquia(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findOperadorHierarquia($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findOperadorHierarq(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findOperadorHierarq($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findTipoLocal(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findTipoLocal($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findLocal(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findLocal($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function findAtividades(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findAtividades($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findIdioma(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findIdioma($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findMoeda(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findMoeda($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findProposta(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findProposta($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findModeloProposta(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findModeloProposta($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findCentroCusto(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findCentroCusto($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findServico(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findServico($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findOperador(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findOperador($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findPerfilAcesso(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findPerfilAcesso($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findTipoMedida(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findTipoMedida($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function findModeloDocumento(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findModeloDocumento($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function findTpOperacao(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findTpOperacao($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findFilial(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findFilial($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findContratosSM(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findContratosSM($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findInterlocutor(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findInterlocutor($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function findJustificativaCDA(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findJustificativaCDA($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findAnexo(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findAnexo($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findServicosExecHCM(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findServicosExecHCM($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }


    private function getFiltro($request)
    {
        if (isset($request->getParameters()["find"])) {
            $filtro = $request->getParameters()["find"];
        } else {
            $filtro = '';
        }
        return $filtro;
    }
}
