<?php

namespace SM\Service;

use SM\Factory\CalendarioLembretesFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use SM\Service\FindService;

class CalendarioLembretesService
{
    protected $entityManager;
    protected $calendarioLembretesFactory;
    protected $Environment;
    protected $newCode;
    protected $findService;

    public function __construct(CalendarioLembretesFactory $calendarioLembretesFactory, Environment $Environment, NewCode $newCode, FindService $findService)
    {
        $this->calendarioLembretesFactory   = $calendarioLembretesFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
        $this->findService                  = $findService;
    }

    public function getCalendarioLembreteContrato($parametros)
    {
        $filtroPeriodoData = '';
        if (isset($parametros["PERIODOINICIAL"]) && $parametros["PERIODOINICIAL"] != 'NULL' ) {
            $filtroPeriodoData = "AND (TRUNC (LEMBRETE.DTHRLEMBRETE) 
                                        BETWEEN TO_DATE('". $parametros["PERIODOINICIAL"] . "', 'DD/MM/YYYY') 
                                        AND DECODE(TO_DATE('" . $parametros["PERIODOFINAL"] . "', 'DD/MM/YYYY'), NULL, 
                                        TO_DATE('31/12/2099', 'DD/MM/YYYY'), TO_DATE('" . $parametros["PERIODOFINAL"] . "', 'DD/MM/YYYY')))" ;
        }

        $arrayContratos = $parametros["NRSEQCONTRATO"];
        $filtroContrato = '';
        if (isset($arrayContratos) && (count($arrayContratos) > 0)) {
            $parametros["NRSEQCONTRATO"] = $this->findService->formatarArray($parametros["NRSEQCONTRATO"]);
            $filtroContrato = " AND LEMBRETE.NRSEQCONTRATO IN (" . $parametros["NRSEQCONTRATO"] . ")";
        }

        $filtroDescricao = '';
        if (isset($parametros["DSLEMBRETECONT"]) && ($parametros["DSLEMBRETECONT"] != "")) {
            $filtroDescricao = " AND LEMBRETE.DSLEMBRETECONT LIKE '%" . $parametros["DSLEMBRETECONT"] . "%'";
        }

        return $this->calendarioLembretesFactory->getCalendarioLembreteContrato($filtroPeriodoData, $filtroContrato, $filtroDescricao);
    }  
}
